Index: formats/format_g723.c
===================================================================
--- formats/format_g723.c	(revision 10193)
+++ formats/format_g723.c	(working copy)
@@ -47,81 +47,13 @@
 
 #define G723_MAX_SIZE 1024
 
-struct ast_filestream {
-	/* First entry MUST be reserved for the channel type */
-	void *reserved[AST_RESERVED_POINTERS];
-	/* This is what a filestream means to us */
-	FILE *f; /* Descriptor */
-	struct ast_filestream *next;
-	struct ast_frame *fr;	/* Frame representation of buf */
-	struct timeval orig;	/* Original frame time */
-	char buf[G723_MAX_SIZE + AST_FRIENDLY_OFFSET];	/* Buffer for sending frames, etc */
-};
-
-
-AST_MUTEX_DEFINE_STATIC(g723_lock);
-static int glistcnt = 0;
-
-static char *name = "g723sf";
-static char *desc = "G.723.1 Simple Timestamp File Format";
-static char *exts = "g723|g723sf";
-
-static struct ast_filestream *g723_open(FILE *f)
-{
-	/* We don't have any header to read or anything really, but
-	   if we did, it would go here.  We also might want to check
-	   and be sure it's a valid file.  */
-	struct ast_filestream *tmp;
-	if ((tmp = malloc(sizeof(struct ast_filestream)))) {
-		memset(tmp, 0, sizeof(struct ast_filestream));
-		if (ast_mutex_lock(&g723_lock)) {
-			ast_log(LOG_WARNING, "Unable to lock g723 list\n");
-			free(tmp);
-			return NULL;
-		}
-		tmp->f = f;
-		tmp->fr = (struct ast_frame *)tmp->buf;
-		tmp->fr->data = tmp->buf + sizeof(struct ast_frame);
-		tmp->fr->frametype = AST_FRAME_VOICE;
-		tmp->fr->subclass = AST_FORMAT_G723_1;
-		/* datalen will vary for each frame */
-		tmp->fr->src = name;
-		tmp->fr->mallocd = 0;
-		glistcnt++;
-		ast_mutex_unlock(&g723_lock);
-		ast_update_use_count();
-	}
-	return tmp;
-}
-
-static struct ast_filestream *g723_rewrite(FILE *f, const char *comment)
-{
-	/* We don't have any header to read or anything really, but
-	   if we did, it would go here.  We also might want to check
-	   and be sure it's a valid file.  */
-	struct ast_filestream *tmp;
-	if ((tmp = malloc(sizeof(struct ast_filestream)))) {
-		memset(tmp, 0, sizeof(struct ast_filestream));
-		if (ast_mutex_lock(&g723_lock)) {
-			ast_log(LOG_WARNING, "Unable to lock g723 list\n");
-			free(tmp);
-			return NULL;
-		}
-		tmp->f = f;
-		glistcnt++;
-		ast_mutex_unlock(&g723_lock);
-		ast_update_use_count();
-	} else
-		ast_log(LOG_WARNING, "Out of memory\n");
-	return tmp;
-}
-
 static struct ast_frame *g723_read(struct ast_filestream *s, int *whennext)
 {
 	unsigned short size;
 	int res;
 	int delay;
 	/* Read the delay for the next packet, and schedule again if necessary */
+	/* XXX is this ignored ? */
 	if (fread(&delay, 1, 4, s->f) == 4) 
 		delay = ntohl(delay);
 	else
@@ -133,7 +65,7 @@
 	}
 	/* Looks like we have a frame to read from here */
 	size = ntohs(size);
-	if (size > G723_MAX_SIZE - sizeof(struct ast_frame)) {
+	if (size > G723_MAX_SIZE) {
 		ast_log(LOG_WARNING, "Size %d is invalid\n", size);
 		/* The file is apparently no longer any good, as we
 		   shouldn't ever get frames even close to this 
@@ -141,50 +73,24 @@
 		return NULL;
 	}
 	/* Read the data into the buffer */
-	s->fr->offset = AST_FRIENDLY_OFFSET;
-	s->fr->datalen = size;
-	s->fr->data = s->buf + sizeof(struct ast_frame) + AST_FRIENDLY_OFFSET;
-	if ((res = fread(s->fr->data, 1, size, s->f)) != size) {
+	s->fr.frametype = AST_FRAME_VOICE;
+	s->fr.subclass = AST_FORMAT_G723_1;
+	s->fr.mallocd = 0;
+	FR_SET_BUF(&s->fr, s->buf, AST_FRIENDLY_OFFSET, size);
+	if ((res = fread(s->fr.data, 1, s->fr.datalen, s->f)) != size) {
 		ast_log(LOG_WARNING, "Short read (%d of %d bytes) (%s)!\n", res, size, strerror(errno));
 		return NULL;
 	}
-#if 0
-		/* Average out frames <= 50 ms */
-		if (delay < 50)
-			s->fr->timelen = 30;
-		else
-			s->fr->timelen = delay;
-#else
-		s->fr->samples = 240;
-#endif
-	*whennext = s->fr->samples;
-	return s->fr;
+	*whennext = s->fr.samples = 240;
+	return &s->fr;
 }
 
-static void g723_close(struct ast_filestream *s)
+static int g723_write(struct ast_filestream *s, struct ast_frame *f)
 {
-	if (ast_mutex_lock(&g723_lock)) {
-		ast_log(LOG_WARNING, "Unable to lock g723 list\n");
-		return;
-	}
-	glistcnt--;
-	ast_mutex_unlock(&g723_lock);
-	ast_update_use_count();
-	fclose(s->f);
-	free(s);
-	s = NULL;
-}
-
-
-static int g723_write(struct ast_filestream *fs, struct ast_frame *f)
-{
 	u_int32_t delay;
 	u_int16_t size;
 	int res;
-	if (fs->fr) {
-		ast_log(LOG_WARNING, "Asked to write on a read stream??\n");
-		return -1;
-	}
+	/* XXX there used to be a check s->fr means a read stream */
 	if (f->frametype != AST_FRAME_VOICE) {
 		ast_log(LOG_WARNING, "Asked to write non-voice frame!\n");
 		return -1;
@@ -198,16 +104,16 @@
 		ast_log(LOG_WARNING, "Short frame ignored (%d bytes long?)\n", f->datalen);
 		return 0;
 	}
-	if ((res = fwrite(&delay, 1, 4, fs->f)) != 4) {
+	if ((res = fwrite(&delay, 1, 4, s->f)) != 4) {
 		ast_log(LOG_WARNING, "Unable to write delay: res=%d (%s)\n", res, strerror(errno));
 		return -1;
 	}
 	size = htons(f->datalen);
-	if ((res = fwrite(&size, 1, 2, fs->f)) != 2) {
+	if ((res = fwrite(&size, 1, 2, s->f)) != 2) {
 		ast_log(LOG_WARNING, "Unable to write size: res=%d (%s)\n", res, strerror(errno));
 		return -1;
 	}
-	if ((res = fwrite(f->data, 1, f->datalen, fs->f)) != f->datalen) {
+	if ((res = fwrite(f->data, 1, f->datalen, s->f)) != f->datalen) {
 		ast_log(LOG_WARNING, "Unable to write frame: res=%d (%s)\n", res, strerror(errno));
 		return -1;
 	}	
@@ -232,43 +138,41 @@
 	return -1;
 }
 
-static char *g723_getcomment(struct ast_filestream *s)
-{
-	return NULL;
-}
+static struct ast_format_lock me = { .usecnt = -1 };
 
+static const struct ast_format g723_1_f = {
+	.name = "g723sf",
+	.exts = "g723|g723sf",
+	.format = AST_FORMAT_G723_1,
+	.write = g723_write,
+	.seek =	g723_seek,
+	.trunc = g723_trunc,
+	.tell =	g723_tell,
+	.read =	g723_read,
+	.buf_size = G723_MAX_SIZE + AST_FRIENDLY_OFFSET,
+	.lockp = &me,
+};
+
 int load_module()
 {
-	return ast_format_register(name, exts, AST_FORMAT_G723_1,
-								g723_open,
-								g723_rewrite,
-								g723_write,
-								g723_seek,
-								g723_trunc,
-								g723_tell,
-								g723_read,
-								g723_close,
-								g723_getcomment);
-								
-								
+	return ast_format_register(&g723_1_f);
 }
 
 int unload_module()
 {
-	return ast_format_unregister(name);
+	return ast_format_unregister(g723_1_f.name);
 }	
 
 int usecount()
 {
-	return glistcnt;
+	return me.usecnt;
 }
 
 char *description()
 {
-	return desc;
+	return "G.723.1 Simple Timestamp File Format";
 }
 
-
 char *key()
 {
 	return ASTERISK_GPL_KEY;
Index: formats/format_h263.c
===================================================================
--- formats/format_h263.c	(revision 10193)
+++ formats/format_h263.c	(working copy)
@@ -48,133 +48,60 @@
 
 /* Portions of the conversion code are by guido@sienanet.it */
 
-struct ast_filestream {
-	void *reserved[AST_RESERVED_POINTERS];
-	/* Believe it or not, we must decode/recode to account for the
-	   weird MS format */
-	/* This is what a filestream means to us */
-	FILE *f; /* Descriptor */
+#define	BUF_SIZE	4096	/* Two Real h263 Frames */
+
+struct h263_desc {
 	unsigned int lastts;
-	struct ast_frame fr;				/* Frame information */
-	char waste[AST_FRIENDLY_OFFSET];	/* Buffer for sending frames, etc */
-	char empty;							/* Empty character */
-	unsigned char h263[4096];				/* Two Real h263 Frames */
 };
 
 
-AST_MUTEX_DEFINE_STATIC(h263_lock);
-static int glistcnt = 0;
-
-static char *name = "h263";
-static char *desc = "Raw h263 data";
-static char *exts = "h263";
-
-static struct ast_filestream *h263_open(FILE *f)
+static int h263_open(struct ast_filestream *s)
 {
-	/* We don't have any header to read or anything really, but
-	   if we did, it would go here.  We also might want to check
-	   and be sure it's a valid file.  */
-	struct ast_filestream *tmp;
 	unsigned int ts;
 	int res;
-	if ((res = fread(&ts, 1, sizeof(ts), f)) < sizeof(ts)) {
+
+	if ((res = fread(&ts, 1, sizeof(ts), s->f)) < sizeof(ts)) {
 		ast_log(LOG_WARNING, "Empty file!\n");
-		return NULL;
+		return -1;
 	}
-		
-	if ((tmp = malloc(sizeof(struct ast_filestream)))) {
-		memset(tmp, 0, sizeof(struct ast_filestream));
-		if (ast_mutex_lock(&h263_lock)) {
-			ast_log(LOG_WARNING, "Unable to lock h263 list\n");
-			free(tmp);
-			return NULL;
-		}
-		tmp->f = f;
-		tmp->fr.data = tmp->h263;
-		tmp->fr.frametype = AST_FRAME_VIDEO;
-		tmp->fr.subclass = AST_FORMAT_H263;
-		/* datalen will vary for each frame */
-		tmp->fr.src = name;
-		tmp->fr.mallocd = 0;
-		glistcnt++;
-		ast_mutex_unlock(&h263_lock);
-		ast_update_use_count();
-	}
-	return tmp;
+	return 0;
 }
 
-static struct ast_filestream *h263_rewrite(FILE *f, const char *comment)
-{
-	/* We don't have any header to read or anything really, but
-	   if we did, it would go here.  We also might want to check
-	   and be sure it's a valid file.  */
-	struct ast_filestream *tmp;
-	if ((tmp = malloc(sizeof(struct ast_filestream)))) {
-		memset(tmp, 0, sizeof(struct ast_filestream));
-		if (ast_mutex_lock(&h263_lock)) {
-			ast_log(LOG_WARNING, "Unable to lock h263 list\n");
-			free(tmp);
-			return NULL;
-		}
-		tmp->f = f;
-		glistcnt++;
-		ast_mutex_unlock(&h263_lock);
-		ast_update_use_count();
-	} else
-		ast_log(LOG_WARNING, "Out of memory\n");
-	return tmp;
-}
-
-static void h263_close(struct ast_filestream *s)
-{
-	if (ast_mutex_lock(&h263_lock)) {
-		ast_log(LOG_WARNING, "Unable to lock h263 list\n");
-		return;
-	}
-	glistcnt--;
-	ast_mutex_unlock(&h263_lock);
-	ast_update_use_count();
-	fclose(s->f);
-	free(s);
-	s = NULL;
-}
-
 static struct ast_frame *h263_read(struct ast_filestream *s, int *whennext)
 {
 	int res;
-	int mark=0;
+	int mark;
 	unsigned short len;
 	unsigned int ts;
+	struct h263_desc *fs = (struct h263_desc *)s->private;
+
 	/* Send a frame from the file to the appropriate channel */
-	s->fr.frametype = AST_FRAME_VIDEO;
-	s->fr.subclass = AST_FORMAT_H263;
-	s->fr.offset = AST_FRIENDLY_OFFSET;
-	s->fr.mallocd = 0;
-	s->fr.data = s->h263;
-	if ((res = fread(&len, 1, sizeof(len), s->f)) < 1) {
+	if ((res = fread(&len, 1, sizeof(len), s->f)) < 1)
 		return NULL;
-	}
 	len = ntohs(len);
-	if (len & 0x8000) {
-		mark = 1;
-	}
+	mark = (len & 0x8000) ? 1 : 0;
 	len &= 0x7fff;
-	if (len > sizeof(s->h263)) {
+	if (len > BUF_SIZE) {
 		ast_log(LOG_WARNING, "Length %d is too long\n", len);
+		len = BUF_SIZE;	/* XXX truncate ? */
 	}
-	if ((res = fread(s->h263, 1, len, s->f)) != len) {
+	s->fr.frametype = AST_FRAME_VIDEO;
+	s->fr.subclass = AST_FORMAT_H263;
+	s->fr.mallocd = 0;
+	FR_SET_BUF(&s->fr, s->buf, AST_FRIENDLY_OFFSET, len);
+	if ((res = fread(s->fr.data, 1, s->fr.datalen, s->f)) != s->fr.datalen) {
 		if (res)
 			ast_log(LOG_WARNING, "Short read (%d) (%s)!\n", res, strerror(errno));
 		return NULL;
 	}
-	s->fr.samples = s->lastts;
+	s->fr.samples = fs->lastts;	/* XXX what ? */
 	s->fr.datalen = len;
 	s->fr.subclass |= mark;
 	s->fr.delivery.tv_sec = 0;
 	s->fr.delivery.tv_usec = 0;
 	if ((res = fread(&ts, 1, sizeof(ts), s->f)) == sizeof(ts)) {
-		s->lastts = ntohl(ts);
-		*whennext = s->lastts * 4/45;
+		fs->lastts = ntohl(ts);
+		*whennext = fs->lastts * 4/45;
 	} else
 		*whennext = 0;
 	return &s->fr;
@@ -216,11 +143,6 @@
 	return 0;
 }
 
-static char *h263_getcomment(struct ast_filestream *s)
-{
-	return NULL;
-}
-
 static int h263_seek(struct ast_filestream *fs, long sample_offset, int whence)
 {
 	/* No way Jose */
@@ -237,44 +159,47 @@
 
 static long h263_tell(struct ast_filestream *fs)
 {
-	/* XXX This is totally bogus XXX */
-	off_t offset;
-	offset = ftell(fs->f);
-	return (offset/20)*160;
+	off_t offset = ftell(fs->f);
+	return offset;	/* XXX totally bogus, needs fixing */
 }
 
+static struct ast_format_lock me = { .usecnt = -1 };
+
+static const struct ast_format h263_f = {
+	.name = "h263",
+	.exts = "h264",
+	.format = AST_FORMAT_H263,
+	.open = h263_open,
+	.write = h263_write,
+	.seek = h263_seek,
+	.trunc = h263_trunc,
+	.tell = h263_tell,
+	.read = h263_read,
+	.buf_size = BUF_SIZE + AST_FRIENDLY_OFFSET,
+	.desc_size = sizeof(struct h263_desc),
+	.lockp = &me,
+};
+
 int load_module()
 {
-	return ast_format_register(name, exts, AST_FORMAT_H263,
-								h263_open,
-								h263_rewrite,
-								h263_write,
-								h263_seek,
-								h263_trunc,
-								h263_tell,
-								h263_read,
-								h263_close,
-								h263_getcomment);
-								
-								
+	return ast_format_register(&h263_f);
 }
 
 int unload_module()
 {
-	return ast_format_unregister(name);
+	return ast_format_unregister(h263_f.name);
 }	
 
 int usecount()
 {
-	return glistcnt;
+	return me.usecnt;
 }
 
 char *description()
 {
-	return desc;
+	return "Raw h263 data";
 }
 
-
 char *key()
 {
 	return ASTERISK_GPL_KEY;
Index: formats/format_h264.c
===================================================================
--- formats/format_h264.c	(revision 10193)
+++ formats/format_h264.c	(working copy)
@@ -47,180 +47,95 @@
 /* Some Ideas for this code came from makeh264e.c by Jeffrey Chilton */
 
 /* Portions of the conversion code are by guido@sienanet.it */
-
-struct ast_filestream {
-	void *reserved[AST_RESERVED_POINTERS];
-	/* Believe it or not, we must decode/recode to account for the
-	   weird MS format */
-	/* This is what a filestream means to us */
-	FILE *f; /* Descriptor */
+#define BUF_SIZE	4096	/* Two Real h264 Frames */
+struct h264_desc {
 	unsigned int lastts;
-	struct ast_frame fr;				/* Frame information */
-	char waste[AST_FRIENDLY_OFFSET];	/* Buffer for sending frames, etc */
-	char empty;							/* Empty character */
-	unsigned char h264[4096];				/* Two Real h264 Frames */
 };
 
-
-AST_MUTEX_DEFINE_STATIC(h264_lock);
-static int glistcnt = 0;
-
-static char *name = "h264";
-static char *desc = "Raw h264 data";
-static char *exts = "h264";
-
-static struct ast_filestream *h264_open(FILE *f)
+static int h264_open(struct ast_filestream *s)
 {
-	/* We don't have any header to read or anything really, but
-	   if we did, it would go here.  We also might want to check
-	   and be sure it's a valid file.  */
-	struct ast_filestream *tmp;
 	unsigned int ts;
 	int res;
-	if ((res = fread(&ts, 1, sizeof(ts), f)) < sizeof(ts)) {
+	if ((res = fread(&ts, 1, sizeof(ts), s->f)) < sizeof(ts)) {
 		ast_log(LOG_WARNING, "Empty file!\n");
-		return NULL;
+		return -1;
 	}
-		
-	if ((tmp = malloc(sizeof(struct ast_filestream)))) {
-		memset(tmp, 0, sizeof(struct ast_filestream));
-		if (ast_mutex_lock(&h264_lock)) {
-			ast_log(LOG_WARNING, "Unable to lock h264 list\n");
-			free(tmp);
-			return NULL;
-		}
-		tmp->f = f;
-		tmp->fr.data = tmp->h264;
-		tmp->fr.frametype = AST_FRAME_VIDEO;
-		tmp->fr.subclass = AST_FORMAT_H264;
-		/* datalen will vary for each frame */
-		tmp->fr.src = name;
-		tmp->fr.mallocd = 0;
-		glistcnt++;
-		ast_mutex_unlock(&h264_lock);
-		ast_update_use_count();
-	}
-	return tmp;
+	return 0;
 }
 
-static struct ast_filestream *h264_rewrite(FILE *f, const char *comment)
-{
-	/* We don't have any header to read or anything really, but
-	   if we did, it would go here.  We also might want to check
-	   and be sure it's a valid file.  */
-	struct ast_filestream *tmp;
-	if ((tmp = malloc(sizeof(struct ast_filestream)))) {
-		memset(tmp, 0, sizeof(struct ast_filestream));
-		if (ast_mutex_lock(&h264_lock)) {
-			ast_log(LOG_WARNING, "Unable to lock h264 list\n");
-			free(tmp);
-			return NULL;
-		}
-		tmp->f = f;
-		glistcnt++;
-		ast_mutex_unlock(&h264_lock);
-		ast_update_use_count();
-	} else
-		ast_log(LOG_WARNING, "Out of memory\n");
-	return tmp;
-}
-
-static void h264_close(struct ast_filestream *s)
-{
-	if (ast_mutex_lock(&h264_lock)) {
-		ast_log(LOG_WARNING, "Unable to lock h264 list\n");
-		return;
-	}
-	glistcnt--;
-	ast_mutex_unlock(&h264_lock);
-	ast_update_use_count();
-	fclose(s->f);
-	free(s);
-	s = NULL;
-}
-
 static struct ast_frame *h264_read(struct ast_filestream *s, int *whennext)
 {
 	int res;
 	int mark=0;
 	unsigned short len;
 	unsigned int ts;
+	struct h264_desc *fs = (struct h264_desc *)s->private;
+
 	/* Send a frame from the file to the appropriate channel */
-	s->fr.frametype = AST_FRAME_VIDEO;
-	s->fr.subclass = AST_FORMAT_H264;
-	s->fr.offset = AST_FRIENDLY_OFFSET;
-	s->fr.mallocd = 0;
-	s->fr.data = s->h264;
-	if ((res = fread(&len, 1, sizeof(len), s->f)) < 1) {
+	if ((res = fread(&len, 1, sizeof(len), s->f)) < 1)
 		return NULL;
-	}
 	len = ntohs(len);
-	if (len & 0x8000) {
-		mark = 1;
-	}
+	mark = (len & 0x8000) ? 1 : 0;
 	len &= 0x7fff;
-	if (len > sizeof(s->h264)) {
+	if (len > BUF_SIZE) {
 		ast_log(LOG_WARNING, "Length %d is too long\n", len);
+		len = BUF_SIZE;	/* XXX truncate */
 	}
-	if ((res = fread(s->h264, 1, len, s->f)) != len) {
+	s->fr.frametype = AST_FRAME_VIDEO;
+	s->fr.subclass = AST_FORMAT_H264;
+	s->fr.mallocd = 0;
+	FR_SET_BUF(&s->fr, s->buf, AST_FRIENDLY_OFFSET, len);
+	if ((res = fread(s->fr.data, 1, s->fr.datalen, s->f)) != s->fr.datalen) {
 		if (res)
 			ast_log(LOG_WARNING, "Short read (%d of %d) (%s)!\n", res, len, strerror(errno));
 		return NULL;
 	}
-	s->fr.samples = s->lastts;
+	s->fr.samples = fs->lastts;
 	s->fr.datalen = len;
 	s->fr.subclass |= mark;
 	s->fr.delivery.tv_sec = 0;
 	s->fr.delivery.tv_usec = 0;
 	if ((res = fread(&ts, 1, sizeof(ts), s->f)) == sizeof(ts)) {
-		s->lastts = ntohl(ts);
-		*whennext = s->lastts * 4/45;
+		fs->lastts = ntohl(ts);
+		*whennext = fs->lastts * 4/45;
 	} else
 		*whennext = 0;
 	return &s->fr;
 }
 
-static int h264_write(struct ast_filestream *fs, struct ast_frame *f)
+static int h264_write(struct ast_filestream *s, struct ast_frame *f)
 {
 	int res;
 	unsigned int ts;
 	unsigned short len;
-	int subclass;
-	int mark=0;
+	int mark;
+
 	if (f->frametype != AST_FRAME_VIDEO) {
 		ast_log(LOG_WARNING, "Asked to write non-video frame!\n");
 		return -1;
 	}
-	subclass = f->subclass;
-	if (subclass & 0x1)
-		mark=0x8000;
-	subclass &= ~0x1;
-	if (subclass != AST_FORMAT_H264) {
+	mark = (f->subclass & 0x1) ? 0x8000 : 0;
+	if ((f->subclass & ~0x1) != AST_FORMAT_H264) {
 		ast_log(LOG_WARNING, "Asked to write non-h264 frame (%d)!\n", f->subclass);
 		return -1;
 	}
 	ts = htonl(f->samples);
-	if ((res = fwrite(&ts, 1, sizeof(ts), fs->f)) != sizeof(ts)) {
-			ast_log(LOG_WARNING, "Bad write (%d/4): %s\n", res, strerror(errno));
-			return -1;
+	if ((res = fwrite(&ts, 1, sizeof(ts), s->f)) != sizeof(ts)) {
+		ast_log(LOG_WARNING, "Bad write (%d/4): %s\n", res, strerror(errno));
+		return -1;
 	}
 	len = htons(f->datalen | mark);
-	if ((res = fwrite(&len, 1, sizeof(len), fs->f)) != sizeof(len)) {
-			ast_log(LOG_WARNING, "Bad write (%d/2): %s\n", res, strerror(errno));
-			return -1;
+	if ((res = fwrite(&len, 1, sizeof(len), s->f)) != sizeof(len)) {
+		ast_log(LOG_WARNING, "Bad write (%d/2): %s\n", res, strerror(errno));
+		return -1;
 	}
-	if ((res = fwrite(f->data, 1, f->datalen, fs->f)) != f->datalen) {
-			ast_log(LOG_WARNING, "Bad write (%d/%d): %s\n", res, f->datalen, strerror(errno));
-			return -1;
+	if ((res = fwrite(f->data, 1, f->datalen, s->f)) != f->datalen) {
+		ast_log(LOG_WARNING, "Bad write (%d/%d): %s\n", res, f->datalen, strerror(errno));
+		return -1;
 	}
 	return 0;
 }
 
-static char *h264_getcomment(struct ast_filestream *s)
-{
-	return NULL;
-}
-
 static int h264_seek(struct ast_filestream *fs, long sample_offset, int whence)
 {
 	/* No way Jose */
@@ -237,44 +152,47 @@
 
 static long h264_tell(struct ast_filestream *fs)
 {
-	/* XXX This is totally bogus XXX */
-	off_t offset;
-	offset = ftell(fs->f);
-	return (offset/20)*160;
+	off_t offset = ftell(fs->f);
+	return offset; /* XXX totally bogus, needs fixing */
 }
 
+static struct ast_format_lock me = { .usecnt = -1 };
+
+static const struct ast_format h264_f = {
+	.name = "h264",
+	.exts = "h264",
+	.format = AST_FORMAT_H264,
+	.open = h264_open,
+	.write = h264_write,
+	.seek = h264_seek,
+	.trunc = h264_trunc,
+	.tell = h264_tell,
+	.read = h264_read,
+	.buf_size = BUF_SIZE + AST_FRIENDLY_OFFSET,
+	.desc_size = sizeof(struct h264_desc),
+	.lockp = &me,
+};
+
 int load_module()
 {
-	return ast_format_register(name, exts, AST_FORMAT_H264,
-								h264_open,
-								h264_rewrite,
-								h264_write,
-								h264_seek,
-								h264_trunc,
-								h264_tell,
-								h264_read,
-								h264_close,
-								h264_getcomment);
-								
-								
+	return ast_format_register(&h264_f);
 }
 
 int unload_module()
 {
-	return ast_format_unregister(name);
+	return ast_format_unregister(h264_f.name);
 }	
 
 int usecount()
 {
-	return glistcnt;
+	return me.usecnt;
 }
 
 char *description()
 {
-	return desc;
+	return "Raw h264 data";
 }
 
-
 char *key()
 {
 	return ASTERISK_GPL_KEY;
Index: formats/format_pcm_alaw.c
===================================================================
--- formats/format_pcm_alaw.c	(revision 10193)
+++ formats/format_pcm_alaw.c	(working copy)
@@ -47,42 +47,25 @@
 #include "asterisk/endian.h"
 #include "asterisk/alaw.h"
 
-#define BUF_SIZE 160		/* 160 samples */
+#define BUF_SIZE 160		/* 160 bytes, and same number of samples */
 
-/* #define REALTIME_WRITE */
+/* #define REALTIME_WRITE */	/* XXX does it work at all ? */
 
-struct ast_filestream {
-	void *reserved[AST_RESERVED_POINTERS];
-	/* Believe it or not, we must decode/recode to account for the
-	   weird MS format */
-	/* This is what a filestream means to us */
-	FILE *f; /* Descriptor */
-	struct ast_frame fr;				/* Frame information */
-	char waste[AST_FRIENDLY_OFFSET];	/* Buffer for sending frames, etc */
-	char empty;							/* Empty character */
-	unsigned char buf[BUF_SIZE];				/* Output Buffer */
+struct pcma_desc {
 #ifdef REALTIME_WRITE
 	unsigned long start_time;
 #endif
 };
 
-
-AST_MUTEX_DEFINE_STATIC(pcm_lock);
-static int glistcnt = 0;
-
-static char *name = "alaw";
-static char *desc = "Raw aLaw 8khz PCM Audio support";
-static char *exts = "alaw|al";
-
 static char alaw_silence[BUF_SIZE];
 
-
 #if 0
 /* Returns time in msec since system boot. */
-static unsigned long get_time(void)
+static unsigned long get_time(struct ast_filestream *s)
 {
 	struct tms buf;
 	clock_t cur;
+	unsigned long *res;
 
 	cur = times( &buf );
 	if( cur < 0 )
@@ -90,79 +73,28 @@
 		ast_log( LOG_WARNING, "Cannot get current time\n" );
 		return 0;
 	}
-	return cur * 1000 / sysconf( _SC_CLK_TCK );
+	res = cur * 1000 / sysconf( _SC_CLK_TCK );
+	if (s) {
+		struct pcma_desc *d = (struct pcma_filestream *)s->private;
+		d->start_time = res;
+	}
+	return res;
 }
 #endif
 
-static struct ast_filestream *pcm_open(FILE *f)
+static int pcm_open(struct ast_filestream *s)
 {
-	/* We don't have any header to read or anything really, but
-	   if we did, it would go here.  We also might want to check
-	   and be sure it's a valid file.  */
-	struct ast_filestream *tmp;
-	if ((tmp = malloc(sizeof(struct ast_filestream)))) {
-		memset(tmp, 0, sizeof(struct ast_filestream));
-		if (ast_mutex_lock(&pcm_lock)) {
-			ast_log(LOG_WARNING, "Unable to lock pcm list\n");
-			free(tmp);
-			return NULL;
-		}
-		tmp->f = f;
-		tmp->fr.data = tmp->buf;
-		tmp->fr.frametype = AST_FRAME_VOICE;
-		tmp->fr.subclass = AST_FORMAT_ALAW;
-		/* datalen will vary for each frame */
-		tmp->fr.src = name;
-		tmp->fr.mallocd = 0;
 #ifdef REALTIME_WRITE
-		tmp->start_time = get_time();
+	get_time(s);
 #endif
-		glistcnt++;
-		ast_mutex_unlock(&pcm_lock);
-		ast_update_use_count();
-	}
-	return tmp;
+	return 0;
 }
 
-static struct ast_filestream *pcm_rewrite(FILE *f, const char *comment)
+static int pcm_rewrite(struct ast_filestream *s, const char *comment)
 {
-	/* We don't have any header to read or anything really, but
-	   if we did, it would go here.  We also might want to check
-	   and be sure it's a valid file.  */
-	struct ast_filestream *tmp;
-	if ((tmp = malloc(sizeof(struct ast_filestream)))) {
-		memset(tmp, 0, sizeof(struct ast_filestream));
-		if (ast_mutex_lock(&pcm_lock)) {
-			ast_log(LOG_WARNING, "Unable to lock pcm list\n");
-			free(tmp);
-			return NULL;
-		}
-		tmp->f = f;
-#ifdef REALTIME_WRITE
-		tmp->start_time = get_time();
-#endif
-		glistcnt++;
-		ast_mutex_unlock(&pcm_lock);
-		ast_update_use_count();
-	} else
-		ast_log(LOG_WARNING, "Out of memory\n");
-	return tmp;
+	return pcm_open(s);
 }
 
-static void pcm_close(struct ast_filestream *s)
-{
-	if (ast_mutex_lock(&pcm_lock)) {
-		ast_log(LOG_WARNING, "Unable to lock pcm list\n");
-		return;
-	}
-	glistcnt--;
-	ast_mutex_unlock(&pcm_lock);
-	ast_update_use_count();
-	fclose(s->f);
-	free(s);
-	s = NULL;
-}
-
 static struct ast_frame *pcm_read(struct ast_filestream *s, int *whennext)
 {
 	int res;
@@ -170,17 +102,15 @@
 
 	s->fr.frametype = AST_FRAME_VOICE;
 	s->fr.subclass = AST_FORMAT_ALAW;
-	s->fr.offset = AST_FRIENDLY_OFFSET;
 	s->fr.mallocd = 0;
-	s->fr.data = s->buf;
-	if ((res = fread(s->buf, 1, BUF_SIZE, s->f)) < 1) {
+	FR_SET_BUF(&s->fr, s->buf, AST_FRIENDLY_OFFSET, BUF_SIZE);
+	if ((res = fread(s->fr.data, 1, s->fr.datalen, s->f)) < 1) {
 		if (res)
 			ast_log(LOG_WARNING, "Short read (%d) (%s)!\n", res, strerror(errno));
 		return NULL;
 	}
-	s->fr.samples = res;
 	s->fr.datalen = res;
-	*whennext = s->fr.samples;
+	*whennext = s->fr.samples = res;
 	return &s->fr;
 }
 
@@ -191,6 +121,7 @@
 	unsigned long cur_time;
 	unsigned long fpos;
 	struct stat stat_buf;
+	struct pcma_filestream *s = (struct pcma_filestream *)fs->private;
 #endif
 
 	if (f->frametype != AST_FRAME_VOICE) {
@@ -204,7 +135,7 @@
 
 #ifdef REALTIME_WRITE
 	cur_time = get_time();
-	fpos = ( cur_time - fs->start_time ) * 8;	/* 8 bytes per msec */
+	fpos = ( cur_time - s->start_time ) * 8;	/* 8 bytes per msec */
 	/* Check if we have written to this position yet. If we have, then increment pos by one frame
 	*  for some degree of protection against receiving packets in the same clock tick.
 	*/
@@ -249,6 +180,7 @@
 	return 0;
 }
 
+/* XXX this is the same as in format_pcm.c, could be merged */
 static int pcm_seek(struct ast_filestream *fs, long sample_offset, int whence)
 {
 	long cur, max, offset = 0;
@@ -306,16 +238,29 @@
 
 static long pcm_tell(struct ast_filestream *fs)
 {
-	off_t offset;
-	offset = ftell(fs->f);
+	off_t offset = ftell(fs->f);
 	return offset;
 }
 
+static struct ast_format_lock me = { .usecnt = -1 };
 
-static char *pcm_getcomment(struct ast_filestream *s)
-{
-	return NULL;
-}
+static const struct ast_format alaw_f = {
+	.name = "alaw",
+	.exts = "alaw|al",
+	.format = AST_FORMAT_ALAW,
+	.open = pcm_open,
+	.rewrite = pcm_rewrite,
+	.write = pcm_write,
+	.seek = pcm_seek,
+	.trunc = pcm_trunc,
+	.tell = pcm_tell,
+	.read = pcm_read,
+	.buf_size = BUF_SIZE + AST_FRIENDLY_OFFSET,
+	.lockp = &me,
+#ifdef	REALTIME_WRITE
+	.desc_size = sizeof(struct pcma_desc),
+#endif
+};
 
 int load_module()
 {
@@ -324,34 +269,24 @@
 	for (index = 0; index < (sizeof(alaw_silence) / sizeof(alaw_silence[0])); index++)
 		alaw_silence[index] = AST_LIN2A(0);
 
-	return ast_format_register(name, exts, AST_FORMAT_ALAW,
-				   pcm_open,
-				   pcm_rewrite,
-				   pcm_write,
-				   pcm_seek,
-				   pcm_trunc,
-				   pcm_tell,
-				   pcm_read,
-				   pcm_close,
-				   pcm_getcomment);
+	return ast_format_register(&alaw_f);
 }
 
 int unload_module()
 {
-	return ast_format_unregister(name);
+	return ast_format_unregister(alaw_f.name);
 }	
 
 int usecount()
 {
-	return glistcnt;
+	return me.usecnt;
 }
 
 char *description()
 {
-	return desc;
+	return "Raw aLaw 8khz PCM Audio support";
 }
 
-
 char *key()
 {
 	return ASTERISK_GPL_KEY;
Index: formats/Makefile
===================================================================
--- formats/Makefile	(revision 10193)
+++ formats/Makefile	(working copy)
@@ -13,6 +13,11 @@
 
 MODS:=$(patsubst %.c,%.so,$(wildcard format_*.c))
 
+MODS:=$(filter-out format_pcm_alaw.so,$(MODS))
+MODS:=$(filter-out format_au.so,$(MODS))
+
+# merged.	format_pcm_alaw.so
+# merged.	format_au.so
 #
 # OGG/Vorbis format
 #
